package no.skippy.agent.examples;

import java.awt.geom.Point2D;

import no.skippy.agent.BasicAgent;
import no.skippy.agent.event.TurnEvent;
import no.skippy.agent.util.CurlingUtils;

public class ScottAgent extends BasicAgent {

	
	public void onTurn(TurnEvent event) {
		Point2D shot = getOposingShotPosition(event);

		int rock8idx = CurlingUtils.toIdx8(event.getRock());
		
		if (event.getRound() < event.getNumberOfRounds() || rock8idx < 7) {
			if (Math.abs(shot.getX()) < 2.5 && !(shot.getY() < -1.829 || shot.getY() > 6.401)) {
				event.setBroom(shot);
				event.setOutTurn((shot.getX() > 0) ? false
						: true);
				event.setSplitTimeMillies(1000);
			} else {
				event.setOutTurn((Math.random() < .5));
				event.setBroom(new Point2D.Double(event.getOutTurn() ? -Math
						.random() : Math.random(), 0.));
				event
						.setSplitTimeMillies(3250 + (Math.random() < .5 ? (int) (-Math
								.random() * 100)
								: (int) (Math.random() * 100)));
			}
		} else {
			while (getMyShotPosition(event).distance(0, 0) > getOposingShotPosition(
					event).distance(0, 0) && getMyShotPosition(event).distance(0, 0) < 1.829) {
				event.setOutTurn((Math.random() < .5));
				event.setBroom(new Point2D.Double(event.getOutTurn() ? -Math
						.random() : Math.random(), 0.));
				event
						.setSplitTimeMillies(3250 + (Math.random() < .5 ? (int) (-Math
								.random() * 100)
								: (int) (Math.random() * 100)));
			}
		}
	}
	
	public Point2D getOposingShotPosition(TurnEvent event) {
		Point2D shot = new Point2D.Double(100, 100);
		for (int rockId : event.getRocksInPlay()) {
			Point2D rockPosition = event.getCurrentPos(rockId);
			if ((event.isPlayerDark() && !event.isRockDark(rockId))
					|| (!event.isPlayerDark() && event.isRockDark(rockId))) {
				if (rockPosition.distance(0, 0) < shot.distance(0, 0)) {
					shot = rockPosition;
				}
			}
		}
		return shot;
	}
	public Point2D getMyShotPosition(TurnEvent event) {
		Point2D shot = new Point2D.Double(100, 100);
		for (int rockId : event.getRocksInPlay()) {
			Point2D rockPosition = event.getCurrentPos(rockId);
			if ((!event.isPlayerDark() && !event.isRockDark(rockId))
					|| (event.isPlayerDark() && event.isRockDark(rockId))) {
				if (rockPosition.distance(0, 0) < shot.distance(0, 0)) {
					shot = rockPosition;
				}
			}
		}
		return shot;
	}
	
	public String getAgentName() {
		return "Scott TakeOut";
	}
}