package no.skippy.agent.examples;

import java.io.File;

import no.skippy.agent.BasicAgent;
import no.skippy.agent.util.Storage;

public class StorageAgent extends BasicAgent {

	private String filePath = StorageAgent.class.getResource("").getFile()
			+ "dummy.xml";

	private String myName;
	
	public void loadResources(Storage service) {

		if (new File(filePath).exists()) // avoid chicken and egg problem
			service.loadObject(String.class, filePath, this);
	}

	public void setup() {
		if (getResource(filePath) != null) {
			myName = (String) getResource(filePath);
			log(getAgentName() + " is ready for some actions");
		}
	}

	public void tearDown(Storage service) {

		String dummy = "Save a single string";
		service.saveResource(dummy, filePath);
		log(getAgentName() + " saved dummy to: " + filePath);
	}

	public String getAgentName() {
		return (myName == null) ? "StorageAgent" : myName;
	}
}
