package no.skippy.agent.skippy.api;

import java.awt.geom.Point2D;
import java.util.List;

import no.skippy.agent.event.TurnEvent;

/**
 * An interface for the output of an agent, that is, an agent's control action.
 * 
 * @author <a href="mailto:frode.aa@gmail.com">Frode Aannevik </a>
 */

public interface Action {

	/**
	 * 
	 * @return list of sub actions.
	 */
	List<Action> getSubActions();

	/**
	 * Execute the action on the event.
	 * 
	 * @param event
	 *            to execute.
	 */
	void execute(TurnEvent event);

	/**
	 * 
	 * @param action
	 *            to set.
	 */
	void setAction(Action action);

	/**
	 * @return broom position property.
	 */
	Point2D getPos();

	/**
	 * @return broom curl property.
	 */
	boolean isOutTurn();

	/**
	 * @return broom split time property.
	 */
	int getSplitTime();

	/**
	 * @return description of the action.
	 */
	String getDescription();

}
