package no.skippy.agent.skippy.api;

public interface Featurizer {

	/**
	 * 
	 * @param state
	 *            to use.
	 * @return returns a feature array of the {@link State}
	 */
	double[] getFeatures(State state);

	/**
	 * Set the feature weights.
	 * 
	 * @param newFeatureWeights
	 *            to set.
	 */
	void setFeatureWeights(double[] newFeatureWeights);

	/**
	 * 
	 * @return feature weights.
	 */
	double[] getFeatureWeights();

	/**
	 * 
	 * @param state
	 *            to use.
	 * @return returns the feature weight description of a {@link State}.
	 */
	String[] getFeatureWeightsDescription(State state);

	/**
	 * 
	 * @param state
	 *            to estimate.
	 * @return estimated value of the {@link State} instance.
	 */
	double getEstimate(State state);

	/**
	 * @return the learning rate used.
	 */
	double getLearningRate();

	/**
	 * Set the learning rate.
	 * 
	 * @param new LearningRate
	 *            to set.
	 */
	void setLearningRate(double learningRate);
}
