package no.skippy.agent.skippy.api;



/**
 * An interface for abstracting the input (i.e. rocks position informations)
 * that an agent receives from the simulator. These states can return an array
 * of double's to represent the state.
 * 
 * @author <a href="mailto:frode.aa@gmail.com">Frode Aannevik </a>
 */
public interface State {
	
	/**
	 * @param estimate
	 *            to set.
	 */
	void setEstimate(double estimate);

	/**
	 * @return estimated value of the state.
	 */
	double getEstimate();

	/**
	 * Get the feature array.
	 * 
	 * @return ordered feature array.
	 */
	double[] getDoubleArray();

	/**
	 * Get description.
	 * 
	 * @return ordered feature description array.
	 */
	String[] getDescription();

}
