package no.skippy.agent.skippy.rlearning;

import java.util.Arrays;

import no.skippy.agent.event.TurnEvent;
import no.skippy.agent.skippy.AgentState;

public class RLAgentStateHammer extends RLAgentState {

	private int hammer;

	public RLAgentStateHammer(TurnEvent event, int rockNumber) {
		super(event, rockNumber);
	}

	public RLAgentStateHammer(AgentState bestState, int rock) {
		super(bestState, rock);
	}

	public void setHammer(boolean hasHammer) {
		if (hasHammer)
			hammer = 1;
		else
			hammer = 0;
	}

	public double[] getDoubleArray() {
		double[] stateArray = { points, myRocksInHouse, notmyRocksInHouse,
				myRocksCovered, notmyRocksCovered, cornerGuard, centerGuard,
				rockNumber, hammer};
		return stateArray;
	}

	public String[] getDescription() {
		String[] descriptionArray = { "Constant.", "Match Points.",
				"Num. of Rocks that is mine and in house.",
				"Num. of Rocks that is NOT mine and in house.",
				"Num. of Rocks that is mine and covered.",
				"Num. of Rocks that is NOT mine and covered.",
				"Num. of Cornerguards.", "Num. of Centerguards.",
				"In rock number in round. (of 8)", "Has Hammer" };
		return descriptionArray;
	}

	public String toString() {
		return super.toString() + "\nRocks played. " + rockNumber
				+ "\n Has hammer " + hammer;
	}

	public boolean equals(Object that) {
		if (this == that)
			return true;
		if (!(that instanceof RLAgentStateHammer)) {
			return false;
		}

		RLAgentState thats = ((RLAgentState) that);
		return Arrays.equals(getDoubleArray(), thats.getDoubleArray());
	}

	public int hashCode() {
		int hash = 7;
		double[] ll = getDoubleArray();
		for (double d : ll)
			hash = (int) (31 * hash + d);
		return hash;
	}
}
