package no.skippy.agent.skippy.rlearning.db;

import java.io.IOException;
import java.util.Properties;

import no.skippy.agent.skippy.rlearning.ActionFactory;

public class DBProperties {
	
	/** property file.*/
	private static String propsToLoad = "mysql.properties";

	/**
	 * Construct properties from reading the properties file.
	 */
	public DBProperties() {
		Properties properties = new Properties();
		
		try {
			properties.load(ActionFactory.class
					.getResourceAsStream(ActionFactory.SELECTED_ACTION));
			propsToLoad = properties.getProperty("databaseproperties");
			properties
					.load(QDataBase.class.getResourceAsStream(propsToLoad));
		} catch (IOException e) {
			e.printStackTrace();
		}
		this.url = properties.getProperty("url");
		this.userName = properties.getProperty("username");
		this.password = properties.getProperty("password");
		this.qtable = properties.getProperty("database");
		this.actionTable = properties.getProperty("actiondb");
		this.stateKey = properties.getProperty("stateKey");
		this.actionKey = properties.getProperty("actionKey");
	}

	public String toString() {
		return String.format("URL: %s, user=%s, pass=%s.", url, userName,
				password);
	}

	
	public String getURL() {
		return String.format("%s%s%s", url, userName, password);
	}

	protected String url;
	protected String userName;
	protected String password;
	protected String qtable;
	protected String actionTable;
	protected String stateKey;
	protected String actionKey;
}