package no.skippy.agent.skippy.rlearning.db;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

public class MergeQTable {
	static String username = "test_mysql_loginblalbalba";
	static String password = "1234";
	static String url = "jdbc:mysql://dhcp-103-121.idi.ntnu.no/rlSkippy";
	static String database = "qtable_bak";
	static String actiondb = "action_bak";

	static String actionKey = "actionID";
	static String stateKey = "stateID";

	static String insertintotable = "Insert into %s values(%s)";
	static String valuesformat = "'%s', %s, %s, %s, %s";

	static int ACTION_HOUSE = 0;
	static int ACTION_GUARD = 1;
	static int ACTION_TAKEOUT = 2;

	public static void maindd(String... args) {
		System.out
				.println("Start moving to a new place, this may take some time...");

		// connect to database
		DBConnection dbNew = new DBConnection(new DBProperties());

		Connection dbOld = getConnection();
		Statement statement = createStatement(dbOld);

		dbNew.connect();
		Statement upstm = dbNew.createStatement();

		// get distinct states

		String distinctStates = "Select distinct stateid from qtable_bak";
		String guardAction = "Select * from qtable_bak where stateid='%s'"
				+ " and (actionid=0 or actionid=2 or actionid=4)";
		String houseAction = "Select * from qtable_bak where stateid='%s'"
				+ " and actionid=1";

		String takeoutAction = "Select * from qtable_bak where stateid='%s'"
				+ " and actionid=3";

		ResultSet result = executeQuery(distinctStates, statement);

		Statement actionStm = createStatement(dbOld);
		int count = 0;
		try {
			while (result.next()) {
				String stateID = result.getString("stateID");
//				stateID = "[2.0, 5.0, 5.0, 1.0, 1.0, 1.0, 0.0, 7.0]";

				ResultSet actions = executeQuery(String.format(guardAction,
						stateID), actionStm);

				//
				// GUARD ACTION MERGE
				double maxQvalue = 0.0;
				double maxReward = 0.0;
				int countused = 0;
				while (actions.next()) {
					double qvalue = actions.getDouble("qvalue");
					double reward = actions.getDouble("reward");
					countused += actions.getInt("countUsed");

					maxReward = Math.max(reward, maxReward);
					maxQvalue = Math.max(qvalue, maxQvalue);
				}
				countused = (countused > 0) ? 1 : 0;

				int rock = Integer.parseInt(stateID.substring(
						stateID.length() - 4, stateID.length() - 3));

				if (rock != 7) {
					maxReward = 0.0; // only reward for last rock
				}

				String newStateId = stateID.substring(0, stateID.length() - 1)
						+ ", %s]";

				String update = String.format(valuesformat, newStateId,
						ACTION_GUARD, maxQvalue, maxReward, countused);
				//				
				String notHammer = String.format(update, "0.0");
				String hammer = String.format(update, "1.0");

				insert(upstm, notHammer);
				insert(upstm, hammer); // hammer

				// HOUSE ACTION
				actions = executeQuery(String.format(houseAction, stateID),
						actionStm);
				{
					actions.first();
					double qvalue = actions.getDouble("qvalue");
					double reward = actions.getDouble("reward");
					countused = actions.getInt("countUsed");

					maxReward = Math.max(reward, 0);
					maxQvalue = Math.max(qvalue, 0);
					countused = (countused > 0 && maxQvalue > 0) ? 1 : 0;

					update = String.format(valuesformat, newStateId,
							ACTION_HOUSE, maxQvalue, maxReward, countused);

					notHammer = String.format(update, "0.0");
					hammer = String.format(update, "1.0");

					insert(upstm, notHammer);
					insert(upstm, hammer); // hammer
				}

				// // TAKE OUT ACTION
				actions = executeQuery(String.format(takeoutAction, stateID),
						actionStm);
				{
					actions.first();
					double qvalue = actions.getDouble("qvalue");
					double reward = actions.getDouble("reward");
					countused = actions.getInt("countUsed");

					maxReward = Math.max(reward, 0);
					maxQvalue = Math.max(qvalue, 0);
					countused = (countused > 0) ? 1 : 0;
					countused = 0;

					update = String.format(valuesformat, newStateId,
							ACTION_TAKEOUT, maxQvalue, maxReward, countused);

					notHammer = String.format(update, "0.0");
					hammer = String.format(update, "1.0");

					insert(upstm, notHammer);
					insert(upstm, hammer); // hammer

				}
				
				count += 6;				

				if (count%1000 == 0) {
					System.out.println("Done " + count + " states. still 472515 left.");
				}
			}

		} catch (SQLException e) {
			e.printStackTrace();
		}

		// close connection
		close(dbOld);
		dbNew.close();

	}

	static void insert(Statement stm, String values) {
		String sql = String.format(insertintotable, "smallqtable", values);
		executeUpdate(sql, stm);
	}

	static Connection getConnection() {
		Connection conn = null;
		try {
			Class.forName("com.mysql.jdbc.Driver").newInstance();
			conn = DriverManager.getConnection(url, username, password);
			return conn;
		} catch (Exception e) {
			System.err.println("Connect error: ");
			e.printStackTrace();
		}
		return null;
	}

	static void close(Connection conn) {
		try {
			conn.close();
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}

	static ResultSet executeQuery(String sql, Statement statement) {

		ResultSet set = null;
		try {
			set = statement.executeQuery(sql);
		} catch (SQLException e) {
			e.printStackTrace();
		}
		return set;
	}

	static int executeUpdate(String sql, Statement statement) {
		int returnValue = -1;
		try {
			returnValue = statement.executeUpdate(sql);
		} catch (SQLException e) {
			e.printStackTrace();
		}
		return returnValue;
	}

	static Statement createStatement(Connection conn) {
		Statement statement = null;
		try {
			statement = conn.createStatement();
		} catch (SQLException e) {
			e.printStackTrace();
		}
		return statement;
	}
}
