package no.skippy.agent.util;

import no.skippy.agent.BasicAgent;

/**
 * Interface for providing read and write for {@link BasicAgent}.
 * @author <a href="mailto:frode.aa@gmail.com">Frode Aannevik </a>
 */
public interface Storage {

	/**
	 * Queue a save task.
	 * 
	 * @param obj
	 *            to convert to XML and save.
	 * @param filePath
	 *            where the XML file is to be saved.
	 */
	void saveResource(Object obj, String filePath);
	
	/**
	 * Queue a save task.
	 * 
	 * @param obj
	 *            to convert to XML and save.
	 * @param filePath
	 *            where the XML file is to be saved.
	 * @param id
	 *            alias to use in the XML class tag.
	 */
	void saveResource(Object obj, String filePath, String id);
	
	/**
	 * Queue a load task.
	 * 
	 * @param cl
	 *            type to load.
	 * @param filePath
	 *            where the XML file is located.
	 * @param owner
	 *            optional agent ref.
	 */
	void loadObject(Class<?> cl, String filePath, BasicAgent owner);
	
	/**
	 * Queue a save task.
	 * 
	 * @param cl
	 *            type to load.
	 * @param filePath
	 *            where the XML file is located.
	 * @param nameId
	 *            if XML alias is used.
	 * @param owner
	 *            optional agent ref.
	 */
	void loadObject(Class<?> cl, String filePath, String nameId,
				BasicAgent owner);
}
