package no.skippy.sim.control;

import java.awt.geom.Point2D;
import java.lang.reflect.InvocationTargetException;

import javax.swing.BoundedRangeModel;
import javax.swing.SwingUtilities;

import org.jcurl.core.ui.BroomPromptModel;
import org.jcurl.core.ui.ChangeManager;
import org.jcurl.core.ui.BroomPromptModel.SplitMemento;

public class AgentBroomControls implements BroomControls {
//	TODO: remove synchronized?
	/** broom to control. */
	private final BroomPromptModel model;
	
	/** brooms change. */
	private ChangeManager changeManager = null;
	
	/**
	 * @param model to control to control.
	 */
	public AgentBroomControls(BroomPromptModel model) {
		this.model = model;
	}
	
	/** {@inheritDoc} */
	public Point2D getBroom() {
		return model.getBroom();
	}

	/** {@inheritDoc} */
	public boolean getOutTurn() {
		return model.getOutTurn();
	}

	/** {@inheritDoc} */
	public BoundedRangeModel getSplitTimeMillies() {
		return model.getSplitTimeMillis();
	}

	/** {@inheritDoc} */
	public void setBroom(final Point2D pos) {
//		XYMemento pre  = new XYMemento(model, model.getBroom());
//		XYMemento post = new XYMemento(model, pos);
//		getChanger().undoable(pre, post);
		try {
			SwingUtilities.invokeAndWait( new Runnable() {
				public void run() {
					model.setBroom(pos);
				}
			});
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (InvocationTargetException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
//		model.setBroom(pos);
	}

	/** {@inheritDoc} */
	public void setOutTurn(final boolean outTurn) {
//		HandleMemento pre  = new HandleMemento(model, model.getOutTurn());
//		HandleMemento post = new HandleMemento(model, !model.getOutTurn());
//		getChanger().undoable(pre, post);
		
		try {
			SwingUtilities.invokeAndWait( new Runnable() {
				public void run() {
					model.setOutTurn(outTurn);
				}
			});
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (InvocationTargetException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
//		model.setOutTurn(outTurn);
	}

	/** {@inheritDoc} */
	public void setSplitTimeMillies(int splitTime) {
		final SplitMemento pre  = new SplitMemento(model, model.getSplitTimeMillis().getValue());
		final SplitMemento post = new SplitMemento(model, splitTime);
		
		try {
			SwingUtilities.invokeAndWait( new Runnable() {
				public void run() {
					getChanger().undoable(pre, post);
				}
			});
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (InvocationTargetException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	private ChangeManager getChanger() {
		return ChangeManager.getTrivial(changeManager);
	}
}
