package no.skippy.sim.control;

import java.awt.geom.Point2D;

import javax.swing.BoundedRangeModel;

import org.jcurl.core.ui.BroomPromptModel;

/**
 * Interface that allows agents to control a broom. {@link BroomPromptModel}
 * @author <a href="mailto:frode.aa@gmail.com">Frode Aannevik </a>
 */
public interface BroomControls {

	/**
	 * @return position of the broom.
	 */
	Point2D getBroom();

	/**
	 * @param pos for the broom.
	 */
	void setBroom(Point2D pos);
	
	/**
	 * @return is curling out.
	 */
	boolean getOutTurn();

	/**
	 * @param outTurn curling.
	 */
	void setOutTurn(boolean outTurn);
	
	/**
	 * @return split time in range <code>1000-5000</code>.
	 */
	BoundedRangeModel getSplitTimeMillies();
	
	/**
	 * @param splitTime in range <code>1000-5000</code>.
	 */
	void setSplitTimeMillies(int splitTime);
}
