package no.skippy.sim.control;

import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import org.jcurl.core.api.ComputedTrajectorySet;

public class ChangeListenerManager implements ChangeListener {

	private final SimulatorApp mainApp;

	public ChangeListenerManager(final SimulatorApp simulatorApp) {
		this.mainApp = simulatorApp;
	}

	public void add(final ComputedTrajectorySet computedTrajectorySet) {
		if (computedTrajectorySet == null) {
			return;
		}
		computedTrajectorySet.getInitialPos().addRockListener(this);
		computedTrajectorySet.getInitialVel().addRockListener(this);
	}

	public void remove(final ComputedTrajectorySet computedTrajectorySet) {
		if (computedTrajectorySet == null) {
			return;
		}
		computedTrajectorySet.getInitialPos().removeRockListener(this);
		computedTrajectorySet.getInitialVel().removeRockListener(this);
	}

	// fires when moving a broom or a rock.
	public void stateChanged(ChangeEvent event) {
		if (mainApp != null) {
			mainApp.setModified(true);
		}
	}
}
