package no.skippy.sim.control;

import java.awt.geom.Point2D;

import no.skippy.sim.view.SimulatorView;

import edu.umd.cs.piccolo.PCamera;
import edu.umd.cs.piccolo.event.PInputEvent;
import edu.umd.cs.piccolo.event.PInputEventListener;
import edu.umd.cs.piccolo.util.PAffineTransform;

public class MouseWheelHandler implements PInputEventListener {

	private static final int WHEEL_DT       = 0;
	private static final double WHEEL_SCALE = 0.10;
	
	private SimulatorView view;
	
	public MouseWheelHandler(SimulatorView view) {
		this.view = view;
	}
	
	public void processEvent(PInputEvent event, int arg1) {
		if (event.isMouseWheelEvent()) {
			// http://groups.google.com/group/piccolo2d-users/browse_thread/thread/8bb79024a41a3ae3?hl=en#
			final int c = event.getWheelRotation();
			final double s = Math.pow(
					1D - WHEEL_SCALE * Math.signum(c), Math.abs(c));
			final Point2D p = event.getPosition();
			final PCamera cam = event.getCamera();
			if (cam.getViewScale() > 20) {
				if (WHEEL_DT <= 0) {
					cam.scaleViewAboutPoint(s, p.getX(), p.getY());
				} else {
					final PAffineTransform t = cam.getViewTransform();
					t.scaleAboutPoint(s, p.getX(), p.getY());
					cam.animateViewToTransform(t, WHEEL_DT);
				}
				view.setViewPort(cam.getViewBounds());
			}
			else cam.setViewScale(20.001);
		}
	}
}
