package no.skippy.sim.control;

import java.awt.geom.Point2D;
import java.util.Random;

import no.skippy.agent.util.CurlingUtils;

public class SimpleDistorter extends BroomDistoter {

	private Random random;
	
	public SimpleDistorter() {
		this.random = new Random();
	}
	
	@Override
	public void setBroom(BroomControls controls) {
		if (controls.getSplitTimeMillies().getValue() <= CurlingUtils.TAKEOUT_SPEED) {
			controls.setBroom(new Point2D.Double(distort(controls.getBroom()
					.getX(), CurlingUtils.feetToMeter(.25)), controls.getBroom()
					.getY()));
		} else {
			controls.setBroom(new Point2D.Double(distort(controls.getBroom()
					.getX(), CurlingUtils.feetToMeter(.5)), controls.getBroom()
					.getY()));
		}
	}

	@Override
	public void setOutTurn(BroomControls controls) {}

	@Override
	public void setSplitTimeMillies(BroomControls controls) {
		if (controls.getSplitTimeMillies().getValue() <= CurlingUtils.TAKEOUT_SPEED) {
			controls.setSplitTimeMillies((int) distort(controls
					.getSplitTimeMillies().getValue(), 15));
		} else {
			controls.setSplitTimeMillies((int) distort(controls
					.getSplitTimeMillies().getValue(), 30));
		}
	}
	
	
	public double distort(double value, double sd) {
		double gaussian = 10;
		while (Math.abs(gaussian*sd) > 2*sd) {
			gaussian = random.nextGaussian();
		}
		return value + gaussian*sd;
	}
}
