package no.skippy.sim.util;

import javax.swing.ActionMap;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JSeparator;

/**
 * Collection of useful GUI functions.
 * 
 * @author <a href="mailto:frode.aa@gmail.com">Frode Aannevik </a>
 */
public class GuiCreator {

	/**
	 * Create a JMenu.
	 * 
	 * @param menuName
	 *            root name. (e.g File, Edit, etc.)
	 * @param actionNames
	 *            to add.
	 * @param actionMap
	 *            containing actions with the aactionName.
	 * @return {@link JMenu} containing actions.
	 */
	public static JMenu createMenu(String menuName, String[] actionNames,
			ActionMap actionMap) {
		JMenu menu = new JMenu();
		menu.setName(menuName);

		for (final String actionName : actionNames) {
			if (actionName.equals("---")) {
				menu.add(new JSeparator());
			} else {
				final JMenuItem menuItem = new JMenuItem(actionMap
						.get(actionName));
				menu.add(menuItem);
			}
		}
		return menu;
	}

}
