package no.skippy.sim.view;

import java.awt.BorderLayout;

import javax.swing.JComponent;

import no.skippy.sim.control.ZoomActions;

import edu.umd.cs.piccolo.PCanvas;
import edu.umd.cs.piccolo.util.PPaintContext;

/**
 * Component for showing a Bird view of the curling ice.
 * 
 * @author <a href="mailto:frode.aa@gmail.com">Frode Aannevik </a>
 */
public class SimulatorBirdView extends JComponent {

	/** */
	private static final long serialVersionUID = 1L;
	private PCanvas canvas;

	/** Constructor. */
	public SimulatorBirdView(SimulatorView sourceView) {
		initComponents();
		if (sourceView instanceof SimulatorView) {
			canvas.getCamera().removeAllChildren();
			canvas.getCamera().addLayer(sourceView.getIceLayer());
		}
	}

	private void initComponents() {
		canvas = new PCanvas();

		setLayout(new BorderLayout());
		add(canvas, BorderLayout.CENTER);

		canvas.setAnimatingRenderQuality(PPaintContext.HIGH_QUALITY_RENDERING);
		canvas
				.setInteractingRenderQuality(PPaintContext.HIGH_QUALITY_RENDERING);
		canvas.setPanEventHandler(null);
		canvas.setZoomEventHandler(null);
	}

	@Override
	public void doLayout() {
		super.doLayout();
		canvas.getCamera().setViewBounds(ZoomActions.HousePlus);
	}

}
