package no.skippy.agent.skippy;


import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertTrue;

import java.util.ArrayList;
import java.util.Collections;

import no.skippy.agent.skippy.api.State;

import org.junit.Before;
import org.junit.Test;

public class TestSkippyAgent {

	ArrayList<State> states = new ArrayList<State>();
	
	ArrayList<Object[]> pairs = new ArrayList<Object[]>();
	
	@Before
	public void setUp() throws Exception {
		for (int i = 0; i < 10; i++) {
			State s = new AgentState(i,i,i,i,i,i,i);
			s.setEstimate(Math.random()*10);
			states.add(s);
			pairs.add(new Object[] { s, "Hello Action :" + i });
		}
	}

	@Test
	public void testTopThreeMoves() {
		
		// test the sorters
		
		Collections.sort(states, new SkippyAgent.StateComparator());
		assertEquals(states.size(),10);
		
		for (int i = 0; i < states.size()-1; i++) {
			assertTrue(states.get(i).getEstimate() > states.get(i + 1)
					.getEstimate());
		}
		
		
		Collections.sort(pairs, new SkippyAgent.StateActionComparator());	
		
		for (int i = 0; i < pairs.size()-1; i++) {
			
			State state = (State) pairs.get(i)[0];
			State next = (State) pairs.get(i+1)[0];
			
			assertTrue(state.getEstimate() > next.getEstimate());
		}
	}
}
