package no.skippy.agent.skippy.rlearning;

import static org.junit.Assert.assertEquals;

import java.io.IOException;
import java.util.Map;
import java.util.Properties;

import no.skippy.agent.skippy.api.Action;

import org.junit.Before;
import org.junit.Test;

public class TestActionFactory {

	Properties props;

	@Before
	public void setUp() throws Exception {
		props = new Properties();

		try {
			props
					.load(ActionFactory.class
							.getResourceAsStream(ActionFactory.AGENT_ACTION_PROPERTIES));
		} catch (IOException e) {} catch (NullPointerException e) {}
	}

	@Test
	public void testGetAllAction() {
		Map<Integer, Action> all = ActionFactory.getInstance().getAllActions();
		for (Integer key : all.keySet()) {
			Action action = all.get(key);
			String actionName = props.getProperty(String.format(
					"action%s.name", key));
			assertEquals(actionName, action.getDescription());
			double expected;
			expected = Double.parseDouble(props.getProperty(String.format(
					"action%s.xpos", key)));
			assertEquals(expected, action.getPos().getX(), 0.01);
			expected = Double.parseDouble(props.getProperty(String.format(
					"action%s.ypos", key)));
			assertEquals(expected, action.getPos().getY(), 0.01);

			boolean out;
			out = Boolean.parseBoolean(props.getProperty(String.format(
					"action%s.outturn", key)));
			assertEquals(out, action.isOutTurn());
			expected = Double.parseDouble(props.getProperty(String.format(
					"action%s.split", key)));
			assertEquals((int) expected, action.getSplitTime());
		}

	}
}
