package no.skippy.agent.skippy.rlearning;

import static org.junit.Assert.assertEquals;

import org.junit.Before;
import org.junit.Test;

public class TestQLearning {

	QLearning learning;
	
	@Before
	public void setup() {
		learning = new QLearning();
	}

	@Test
	public void testGetLearningRate() {
		double factor = 1000.0;
		
		int times = 0;
		double expected = learning.MAX_LEARNING_RATE;
		assertEquals(expected, learning.getLearningRate(times), 0.0);
		
		times = 100;
		expected = factor * learning.MAX_LEARNING_RATE / (factor + times); 
		assertEquals(expected, learning.getLearningRate(100), 0.0);
		
	}
	
	@Test
	public void testC() {
		
		int stateUsed = 0;
		int actionUsed = 0;
		
		double expected = 0.0;
		assertEquals(expected, QLearning.C(stateUsed, actionUsed), 0.0);
		
		expected = 4.674;
		stateUsed = 55445;
		actionUsed = 1;
		assertEquals(expected, QLearning.C(stateUsed, actionUsed), 0.0001);
		
		expected = 0.4674;
		stateUsed = 55445;
		actionUsed = 100;
		assertEquals(expected, QLearning.C(stateUsed, actionUsed), 0.0001);
	}

}
