package no.skippy.sim.control;

import java.io.IOException;
import java.net.URL;

import org.apache.commons.logging.Log;
import org.jcurl.core.api.ComputedTrajectorySet;
import org.jcurl.core.api.TrajectorySet;
import org.jcurl.core.io.IONode;
import org.jcurl.core.io.IOTrajectories;
import org.jcurl.core.io.JCurlSerializer;
import org.jcurl.core.log.JCLoggerFactory;

public class LoadJCurl {
	
	private static Log log = JCLoggerFactory.getLogger(LoadJCurl.class);
	
	public final static ComputedTrajectorySet load(URL document) {
		
		IONode node;
		final IOTrajectories it;
		TrajectorySet ts = null;
//		System.out.println(document);
		try {
			node = new JCurlSerializer().read(document);
			it = (IOTrajectories) node;
			ts  = it.trajectories().get(0);
		} catch (IOException e) {
			log.warn("faild to load document." + document + e);
		}
		
		return (ts==null)?null:(ComputedTrajectorySet) ts;
	}

}
