package no.skippy.sim.control;

import java.awt.geom.Point2D;

import javax.swing.BoundedRangeModel;

import junit.framework.TestCase;
import no.skippy.sim.control.AgentBroomControls;

import org.jcurl.core.ui.TrajectoryBroomPromptWrapper;
import org.junit.Test;

public class SimAgentControllsTest extends TestCase {

	private final double newPos = 1000.3;
	private final int newSplitValue = 1003;

	private TrajectoryBroomPromptWrapper broomModel;
	public AgentBroomControls agentController;

	protected void setUp() throws Exception {
		super.setUp();
		broomModel = new TrajectoryBroomPromptWrapper();
		agentController = new AgentBroomControls(broomModel);
	}

	@Test
	public void testGetBroom() {
		Point2D expected = broomModel.getBroom();
		Point2D actual = agentController.getBroom();
		assertEquals(expected, actual);
	}

	@Test
	public void testGetOutTurn() {
		boolean expected = broomModel.getOutTurn();
		boolean actual = agentController.getOutTurn();
		assertEquals(expected, actual);
	}

	@Test
	public void testGetSplitTimeMillies() {
		BoundedRangeModel expected = broomModel.getSplitTimeMillis();
		BoundedRangeModel actual = agentController.getSplitTimeMillies();
		assertEquals(expected, actual);
	}

	@Test
	public void testSetBroom() {
		Point2D expected = new Point2D.Double(newPos, newPos);
		agentController.setBroom(expected);
		assertEquals(expected, agentController.getBroom());
	}

	@Test
	public void testSetOutTurn() {
		boolean expected = !broomModel.getOutTurn();

		agentController.setOutTurn(expected);
		assertEquals(expected, agentController.getOutTurn());
	}

	@Test
	public void testSetSplitTimeMillies() {
		int expected = newSplitValue;

		agentController.setSplitTimeMillies(expected);
		assertEquals(expected, agentController.getSplitTimeMillies().getValue());
	}

}
